handytag = {

	currentSource:'',
	
	toggleTagsFrom: function(source){
		if(this.currentsource=='delicious')
			{
			this.stopDelicious();
			}
		this.currentsource=source;
		if(source=='meta')
			{
			this.meta();
			}
		else if(source=='delicious')
			{
			this.delicious();
			}
		else if(source=='kgen')
			{
			this.searchKGen();
			}
		else if(source=='perso')
			{
			this.toggleTagsSelect();
			}
	},

	meta: function(){
		// on récupère les métas de la page courante
		var metas = window.parent.getBrowser().contentDocument.getElementsByTagName("META");

		var meta; // variable pour stocker la méta en cours de traitement
		var tabTags = new Array(); // tableau pour stocker les mots clés trouvés
		for(var i = 0 ; i < metas.length ; i++){ // on parcours toutes les métas
			meta = "" + metas[i].getAttribute("name"); // on stocke la méta courante
			if( meta.toLowerCase() == "keywords"){ // si on rencontre la méta "keywords" , on stocke son contenu
				tabTags = metas[i].getAttribute("content").split(/(?:[,+;]+)/); // on sépare tous les mots clés dans le tableau tabTags
				break;
			}
		}

		handytag.addTagsSelector(tabTags); // on organise et affiche le résultat	
	},

	deliciousReq: null,

	delicious: function(){

		// On crée des instance de classe de Firefox
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		var hash = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
		// on récupère l'adresse URI de l'adresse courante en retirant les marqueurs de signet (ou balise)
		// ex : "http://www.xulplanet.com/references/objref/Node.html#method_hasAttributes" => "http://www.xulplanet.com/references/objref/Node.html"
		var tString= window.parent.getBrowser().contentDocument.location.href.split('#')[0];

		converter.charset = "UTF-8"; // On utilise le codage UTF-8
		var result = {}; // pour stoquer le resultat
		var data = converter.convertToByteArray(tString, result); // data est un array de bytes
		hash.init(hash.MD5); // On codera en MD5
		hash.update(data, data.length); // On indique la variable à coder est sa longueur
		var md5h = hash.finish(false); // false pour avoir une valeurs en binaire

		// return the two-digit hexadecimal code for a byte
		function toHexString(charCode){
			return ("0"+charCode.toString(16)).slice(-2);
		}
		// On converti le code binaire en un string hexadecimal
		var repMD5 = [toHexString(md5h.charCodeAt(i)) for (i in md5h)].join("");
		repMD5 = repMD5.substring(0, 32);

		this.deliciousReq = new XMLHttpRequest(); // On crée un objet XMLHttpRequest
		// On initialise la requête en spécifiant la méthode GET , l'URL des RSS de del.icio.us et le mode asynchrone ( true ) 
		this.deliciousReq.open('GET', 'http://feeds.delicious.com/rss/url/'+ repMD5, true);
		//alert('http://feeds.delicious.com/rss/url/'+ repMD5);	
		// exemple : petite partie d'une page XML des page RSS de delicious
		//      <rdf:Bag>
		//        <rdf:li rdf:resource="http://delicious.com/tag/cr%C3%A9ation"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/site"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/internet"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/conforme"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/norme"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/standard"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/accessibilit%C3%A9"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/sites"/>
		//        <rdf:li rdf:resource="http://delicious.com/tag/agence"/>
		//      </rdf:Bag>

		// La fonction récupèrera la réponse du server auquel on enverra la requête
		this.deliciousReq.onreadystatechange = function (){
			if (handytag.deliciousReq.readyState == 4){
				if(handytag.deliciousReq.status == 200){

					var root = handytag.deliciousReq.responseXML; // On récupere le résultat de la requete au format XML
					var roots = root.getElementsByTagName("rdf:Bag"); // On sélestionne toutes les balises "Bag"
					var rep = new Array(); // tableau pour stocker les mots clés trouvés
					var nbRep = 0; // nombre de mots clés trouvés
					var mots, motDecode, word;
					for(var i = 0 ; i < roots.length ; i++){ // on parcours toutes les "Bag"
						mots = roots[i].getElementsByTagName("rdf:li");// On sélectionne toutes les balises "li" se trouvant dans les "Bag" 

						for(var j = 0 ; j < mots.length ; j++){ // on parcours toutes les "li"
							// On décode l'adresse URI pour bien afficher les symbole comme "é"
							// attribut de substring à 25 pour retirer "http://delicious.com/tag/"
							 // on sépare tous les mots clés dans le tableau rep
							//alert(decodeURI(((mots[j].getAttribute("rdf:resource"))+"").substring(25)));
							//if (decodeURI(((mots[j].getAttribute("rdf:resource"))+"").substring(25)) != "")
							word=decodeURI(((mots[j].getAttribute("rdf:resource"))+"").substring(29));
							if(rep.indexOf(word)<0)
								rep[nbRep++] = word;

						}
					}
					handytag.addTagsSelector(rep); // on organise et affiche le résultat
				}
				else
					dump("Error loading page\n"); // On affiche un message d'erreur dans la console
			handytag.deliciousReq=null;
			}
		};
		this.deliciousReq.send(null); // On envoye la requête HTTP au serveur
	},

	stopDelicious: function(){
		if(this.deliciousReq)
			this.deliciousReq.abort();
	},

	kgenBgThread:null,
  
	searchKGen: function(){
		// On récupère les mots indésirables dans le fichiers handitag.properties
		var myHandytagProperties = document.getElementById("handytag-properties");
		var string = myHandytagProperties.getString('extensions.handytag@elitwork.com.ignoredwords');

		// tableau des mots indésirables
		var ignoredWords = new Array();
		ignoredWords = string.split(/(?:[ ,+;]+)/); // on sépare tous les mots clés dans le tableau ignoredWords

		
		
		function KGen(minLength, minRepeat, minWeight, tagsWeight, attributesWeight, ignoredWords, wordSeparators, wordChainLength, spellCheckEngine)
			{
			// Initializing values
			this.words = new Array();
			this.curWordChain = new Array();
			this.weightTot = 0;
			this.repeatTot = 0;
			this.wordsTot = 0;
			this.rightWords = 0;
			this.badWords = 0;
			this.textChars = 0;
			// Initializing options
			this.minLength = (minLength?minLength:2);
			this.minRepeat = (minRepeat?minRepeat:2);
			this.minWeight = (minWeight?minWeight:2);
			if(tagsWeight&&typeof tagsWeight === 'Array')
				{ this.tagsWeight = tagsWeight; }
			else
				{
				this.tagsWeight = new Array();
				this.tagsWeight['title']=12;
				this.tagsWeight['h1']=10;
				this.tagsWeight['h2']=8;
				this.tagsWeight['h3']=6;
				this.tagsWeight['h4']=4;
				this.tagsWeight['h5']=3;
				this.tagsWeight['h6']=2;
				this.tagsWeight['strong']=3;
				this.tagsWeight['em']=2;
				this.tagsWeight['dt']=3;
				this.tagsWeight['style']=0;
				this.tagsWeight['script']=0;
				}
			if(attributesWeight&&typeof attributesWeight === 'Array')
				{ this.attributesWeight = attributesWeight;	}
			else
				{
				this.attributesWeight=new Array();
				this.attributesWeight['title']=1;
				this.attributesWeight['alt']=1;
				this.attributesWeight['summary']=1;
				this.attributesWeight['content']=1;
				}
			this.ignoredWords = ignoredWords;
			this.wordSeparators = (wordSeparators?wordSeparators:" {}+()[]!?;.,'\":|-_/\<>");
			this.spellCheckEngine = spellCheckEngine;
			this.wordChainLength = (wordChainLength?wordChainLength:1);
			};
		KGen.prototype.filter = function ()
			{
			for(var i=0; i<this.words.length; i++)
				{
				var j=i;
				var k=0;
				while(i<this.words.length&&(this.words[i].repeat<this.minRepeat||this.words[i].weight<this.minWeight))
					{
					i++; k++;
					}
				if(k>0) { this.words.splice(j,k); i=j; }
				}
			}
		KGen.prototype.getElementWords = function (element, ratio)
			{
			if(this.wordChainLength&&element.nodeName=='div'&&element.nodeName=='blockquote'
				&&element.nodeName=='h1'&&element.nodeName=='h2'&&element.nodeName=='h3'&&element.nodeName=='h4'&&element.nodeName=='h5'&&element.nodeName=='h6'
				&&element.nodeName=='p'&&element.nodeName=='br'&&element.nodeName=='pre'&&element.nodeName=='address'
				&&element.nodeName=='ol'&&element.nodeName=='ul'&&element.nodeName=='dl'&&element.nodeName=='li'&&element.nodeName=='dt'&&element.nodeName=='dd')
				this.curWordChain= new Array();
			if(element.hasAttributes())
				{
				for(var i=element.attributes.length-1; i>=0; i--)
					{
					if(this.attributesWeight[element.attributes[i].name]&&this.attributesWeight[element.attributes[i].name])
						this.getWordsFrom(element.attributes[i].value, this.attributesWeight[element.attributes[i].name]);
					}
				}
			if(this.tagsWeight[element.nodeName.toLowerCase()]&&this.tagsWeight[element.nodeName.toLowerCase()]>1)
				{
				ratio+=this.tagsWeight[element.nodeName.toLowerCase()];
				}
			else if(ratio==0) { ratio+=1; }
			var x = element.childNodes.length;
			for(var i=0; i<x; i++)
				{
				if(element.childNodes[i].nodeName.toLowerCase()=='#text'&&((this.tagsWeight[element.nodeName.toLowerCase()]===undefined)||this.tagsWeight[element.nodeName.toLowerCase()]>0))
					this.getWordsFrom(element.childNodes[i].data,ratio);
				else
					this.getElementWords(element.childNodes[i],ratio);
				}
			}
		KGen.prototype.getWordsFrom = function (string, ratio)
			{
			var curString;
			var curWord;
			var x=string.length;
			this.textChars+=x;
			for(var i=0; i<x; i++)
				{
				curString='';
				while(i<x&&string[i]!='\f'&&string[i]!='\n'&&string[i]!='\r'&&string[i]!='\t'
				&&string[i]!='\v'&&string[i]!='\u00A0'&&string[i]!='\u2028'&&string[i]!='\u2029'
				&&this.wordSeparators.indexOf(string[i])===-1)
					{
					curString+=string[i]; i++;
					}
				if(curString.length>this.minLength)
					{
					this.wordsTot++;
					curString = curString.toLowerCase();
					var y = this.words.length;
					for(var j=0; j<y; j++)
						{
						if(this.words[j].name==curString)
							{
							
							break;
							}
						}
					curWord=this.getListedWord(curString);
					if(curWord)
						{
						curWord.weight+=ratio;
						curWord.repeat++;
						curWord.positions.push(this.wordsTot);
						this.repeatTot++;
						this.weightTot+=ratio;
						}
					else
						{
						if(this.ignoredWords)
							{
							var ignore=false;
							for(var k=this.ignoredWords.length-1; k>=0; k--)
								{
								if(curString == this.ignoredWords[k])
									{
									ignore=true; break;
									}
								}
							if(ignore)
								{
								this.curWordChain=new Array();
								continue;
								}
							}
						curWord = new Word(curString, ratio, this.wordsTot);
						this.words.push(curWord);
						this.repeatTot++;
						this.weightTot+=ratio;
						if (this.spellCheckEngine&&this.spellCheckEngine.check(curString))
							{
							curWord.isRight=true;
							this.rightWords++;
							}
						else
							this.badWords++;
						}
					if(this.wordChainLength)
						{
						if(this.curWordChain.length>=this.wordChainLength)
							this.curWordChain.splice(0,1);
						var y=this.curWordChain.length;
						var match=false;
						for(var k=0; k<y; k++)
							{
							if(this.curWordChain[k].name==curWord.name)
								{
								this.curWordChain.splice(0,k);
								match=true;
								break;
								}
							}
						if(match)
							continue;
						this.curWordChain.push(curWord);
						var y=this.curWordChain.length;
						if(y>1)
							{
							var sentence='';
							for(var k=0; k<y; k++)
								{
								sentence+=(sentence?' ':'')+this.curWordChain[k].name;
								if(k>0)
									{
									var curSentence=this.getListedWord(sentence)
									if(curSentence)
										{
										curSentence.weight+=ratio;
										curSentence.repeat++;
										curSentence.positions.push(this.wordsTot-1);
										}
									else
										{
										this.words.push(new Word(sentence, ratio, this.wordsTot-1));
										}
									}
								}
							}
						}
					}
				else if(curString.length>1)
					this.wordsTot++;
				}
			}
		KGen.prototype.getListedWord = function (string)
			{
			for(var i=this.words.length-1; i>=0; i--)
				{
				if(this.words[i].name==string)
					{
					return this.words[i];
					}
				}
			return null;
			}
		KGen.prototype.sort = function (criter)
			{
			if(criter=='repeat')
				{
				var sortFn = function(a,b)
					{
					if (a.repeat > b.repeat) return -1;
					if (a.repeat < b.repeat) return 1;
					return 0;
					}
				}
			else if(criter=='length')
				{
				var sortFn = function(a,b)
					{
					if (a.length > b.length) return -1;
					if (a.length < b.length) return 1;
					return 0;
					}
				}
			else if(criter=='name')
				{
				var sortFn = function(a,b)
					{
					for(var i=0; i<a.length && (i==0||a.name[i]==a.name[i]); i++)
						{
						if ((!b.name[i])||a.name[i]>b.name[i]) return 1;
						if (a.name[i]<b.name[i]) return -1;
						}
					return 0;
					}
				}
			else if(criter=='fposition')
				{
				var sortFn = function(a,b)
					{
					if (a.getFirstPosition() > b.getFirstPosition()) return -1;
					if (a.getFirstPosition() < b.getFirstPosition()) return 1;
					return 0;
					}
				}
			else if(criter=='aposition')
				{
				var sortFn = function(a,b)
					{
					if (a.getAveragePosition() > b.getAveragePosition()) return -1;
					if (a.getAveragePosition() < b.getAveragePosition()) return 1;
					return 0;
					}
				}
			else
				{
				var sortFn = function(a,b)
					{
					if (a.weight > b.weight) return -1;
					if (a.weight < b.weight) return 1;
					return 0;
					}
				}
			this.words.sort(sortFn);
			}

		function Word(name,weight,position)
			{
			this.name = name;
			this.weight = weight;
			this.repeat = 1;
			this.length = name.length;
			this.positions = new Array();
			this.positions[0]=position;
			this.isRight=false;
			};

		Word.prototype.getFirstPosition = function ()
			{
			return this.positions[0];
			}

			Word.prototype.getFirstPositionPercents = function (wordTot)
			{
			return this.getFirstPosition()/wordTot*100;
			}

		Word.prototype.getAveragePosition = function ()
			{
			var positionSum=0;
			var y=this.positions.length;
			for(var i=0; i<y; i++)
				positionSum+=this.positions[i];
			return Math.round(positionSum/this.positions.length);
			}

		Word.prototype.getAveragePositionPercents = function (wordTot)
			{
			return Math.round((this.getAveragePosition()/wordTot)*10000)/100;
			}

			Word.prototype.getWeightPercents = function (weightTot)
			{
			return Math.round((this.weight/weightTot)*10000)/100;
			}

		Word.prototype.getRepeatPercents = function (repeatTot)
			{
			return Math.round((this.repeat/repeatTot)*10000)/100;
			}

		// Start KGen
		var element = window.parent.getBrowser().contentDocument.documentElement;	// on stocke la page courante
		var minLength = 2; // taille des mots minimun à traiter
		var minRepeat = 2; // nombre minimum de répétition des mots à retenir 
		var minWeight = 2;  // poids minimum des mots à retenir
		var tagsWeight = new Array(); // tableau des poids par rapport aux tags
		tagsWeight["title"] = 12;
		tagsWeight["h1"] = 10;
		tagsWeight["h2"] = 8;
		tagsWeight["h3"] = 6;
		tagsWeight["h4"] = 4;
		tagsWeight["h5"] = 3;
		tagsWeight["h6"] = 2;
		tagsWeight["strong"] = 3;
		tagsWeight["em"] = 2;
		tagsWeight["script"] = 0;
		tagsWeight["style"] = 0;
		var attributesWeight = new Array(); // tableau des poids par rapport aux attribus
		attributesWeight["alt"] = 1;
		attributesWeight["title"] = 1;
		attributesWeight["summary"] = 1;
		attributesWeight["content"] = 1;
		var wordSeparators = " {}+()[]!?;.,'\":|-_/\\<>"; // liste des séparateurs de mots (ne pas oublier l'espace)
		// on appelle KGen
		var curKGen = new KGen(minLength, minRepeat, minWeight, tagsWeight, attributesWeight, ignoredWords, wordSeparators);
		curKGen.getElementWords(element);
		result=new Array();
		for(var i=0; i<curKGen.words.length ; i++)
		result[i]=curKGen.words[i].name; // on sépare tous les mots clés dans le tableau résult
		handytag.addTagsSelector(result);
		},
	
	// Début : Fonctions pour l'ajout de l'Overlay dynamique
	loadOverlayOk: false,

	listenerEvent: function(){
		window.removeEventListener("load",handytag.listenerEvent,false); // une fois la fonction appelée, on arrete l'écoute

		var BookOverlay;
		BookOverlay = document.getElementById("editBookmarkPanelContent"); // on récupère le bookmark dynamique
		BookOverlay.addEventListener("load", handytag.listenerDynamicBookmark, true);	// On lance l'écoute des évènements sur le bookmark dynamique
	},

	listenerDynamicBookmark: function(){	// On n'exécute une seule fois le loadOverlay de dynamic-overlay.xul
		if(!handytag.loadOverlayOk){
			handytag.loadOverlayOk=true;
			document.loadOverlay("chrome://handytag/content/dynamic-overlay.xul", null);
		}
	},
	// Fin : Fonctions pour l'ajout de l'Overlay dynamique

	/*
	 l.738 de "editBookmarkOverlay"

	  _rebuildTagsSelectorList: function EIO__rebuildTagsSelectorList() {
	    var tagsSelector = this._element("tagsSelector");
	    if (tagsSelector.collapsed)
	      return;

	    while (tagsSelector.hasChildNodes())
	      tagsSelector.removeChild(tagsSelector.lastChild);

	    var tagsInField = this._getTagsArrayFromTagField();
	    var allTags = PlacesUtils.tagging.allTags;
	    for (var i = 0; i < allTags.length; i++) {
	      var tag = allTags[i];
	      var elt = document.createElement("listitem");
	      elt.setAttribute("type", "checkbox");
	      elt.setAttribute("label", tag);
	      if (tagsInField.indexOf(tag) != -1)
	        elt.setAttribute("checked", "true");

	      tagsSelector.appendChild(elt);
	    }
	  },
	  */
	toggleTagsSelect: function(){ // On ouvre le panneau de sélection des tags avec les tags personnels
		
		//var tagsSelector = gEditItemOverlay._element("tagsSelector");
		//var expander = gEditItemOverlay._element("tagsSelectorExpander");
		var handytagSelector = gEditItemOverlay._element("tagsSelector");
		var handytagSelectorRow = gEditItemOverlay._element("tagsSelectorRow");
		
		if ((handytagSelectorRow&&handytagSelectorRow.collapsed)||((!handytagSelectorRow)&&handytagSelector.collapsed)) { // si le panneau est fermer, on l'ouvre et on affiche les tags personnels
			gEditItemOverlay.toggleTagsSelector();
			//handytagSelector.collapsed = false;
		}
		else{// si le panneau est ouvert, on affiche les tags personnels
			//expander.className = "expander-up";
			//expander.setAttribute("tooltiptext", expander.getAttribute("tooltiptextup"));
			gEditItemOverlay._rebuildTagsSelectorList();
		}
	},

	addTagsSelector: function(tabTags){

		handytag.toggleTagsSelect();
		var handytagSelector = gEditItemOverlay._element("tagsSelector");

		// on retire les tags non checkés pour ne pas qu'il s'affichent
		for (var a = 0; a < handytagSelector.childNodes.length; a++)
			if(handytagSelector.childNodes[a].getAttribute('checked')!="true"){
				handytagSelector.removeChild(handytagSelector.childNodes[a]);
				a--;
			}

		var newTags = new Array();
		var position;
		
		for(var i = 0; i < tabTags.length; i++){
			for(var j=0; j<handytagSelector.childNodes.length && i < tabTags.length; j++)
				if(handytagSelector.childNodes[j].getAttribute('label').toLowerCase() == tabTags[i].toLowerCase()){
					i++;
					j=0;
				}

			if(i < tabTags.length){
				if(newTags.length == 0)
					newTags[0] = tabTags[i];
				else{
					position = newTags.length;
					while( position > 0 && newTags[position-1] > tabTags[i] ){ // on décale la fin du tableau
						newTags[position] = newTags[position-1];
						position--;
					}
					newTags[position] = tabTags[i]; // on ajoute le nouveau tag
				}
			}
		}

		for(var t = 0; t < newTags.length; t++){
			var elt = document.createElement("listitem");
			elt.setAttribute("type", "checkbox");
			elt.setAttribute("label", newTags[t]);
			handytagSelector.appendChild(elt);
		}
	},

	detail: function(){ // pour afficher la popup "à propos"
		window.open("chrome://handytag/content/detailHandytag.html", "Détails",
			"width=236, height=455, directories=no, menubar=no, status=no, location=no, scrollbars=no, resizable=no, left=500, top=100, fullscreen=no");
	}

}

if(!handytag)
	var handytag={};

window.addEventListener("load",handytag.listenerEvent,false); // on écoute les évènement de la fenêtre